Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ssrHelper = require('../ssrHelper');

exports['default'] = function (headParamsFn) {
  var name = 'headParams';
  var cycle = {
    name: name,
    appendToHead: function () {
      function appendToHead($head, options) {
        var _headParamsFn = headParamsFn(options),
            title = _headParamsFn.title,
            description = _headParamsFn.description;

        $head.append('<title>' + String(title) + '</title>');
        $head.append('<meta name="description" content="' + String(description) + '">');
      }

      return appendToHead;
    }()
  };

  return (0, _ssrHelper.ssrDecorator)(cycle);
};

module.exports = exports['default'];