Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ssrHelper = require('../ssrHelper');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports['default'] = function (fn) {
  var name = 'preloadedState';
  var cycle = {
    name: name,
    setOptions: function () {
      var _ref = _asyncToGenerator(function* (props, options) {
        var data = yield fn(props, options);
        return { preloadedState: data };
      });

      return function () {
        function setOptions(_x, _x2) {
          return _ref.apply(this, arguments);
        }

        return setOptions;
      }();
    }(),
    appendToHead: function () {
      function appendToHead($head, options) {
        var preloadedState = options.preloadedState,
            initialState = options.initialState;

        var state = preloadedState;
        if (initialState) {
          state = Object.assign({}, initialState, preloadedState);
        }
        $head.append('<script data-coren>\n        window.__PRELOADED_STATE__ = ' + String(JSON.stringify(state)) + '\n        </script>');
      }

      return appendToHead;
    }()
  };

  return (0, _ssrHelper.ssrDecorator)(cycle);
};

module.exports = exports['default'];