Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _ssrHelper = require('../ssrHelper');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

exports['default'] = function (_ref) {
  var reducer = _ref.reducer;

  var name = 'reactRedux';

  var wrapSSR = function wrapSSR(appElement, options) {
    var store = void 0;
    if (options.preloadedState) {
      var preloadedState = options.preloadedState;

      store = (0, _redux.createStore)(reducer, preloadedState);
    } else {
      store = (0, _redux.createStore)(reducer);
    }
    return _react2['default'].createElement(
      _reactRedux.Provider,
      { store: store },
      appElement
    );
  };
  wrapSSR.displayName = 'wrapReactReduxCompoent';

  var cycle = {
    name: name,
    wrapSSR: wrapSSR
  };

  return (0, _ssrHelper.ssrDecorator)(cycle);
};

module.exports = exports['default'];