Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _reactIntl = require('react-intl');

var _ssrHelper = require('../ssrHelper');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

exports['default'] = function (_ref) {
  var reducer = _ref.reducer;

  var name = 'reactRouterRedux';

  var setOptions = function setOptions() {
    // save initialstate
    var initialState = (0, _redux.createStore)(reducer).getState();
    return { initialState: initialState };
  };

  var wrapSSR = function wrapSSR(appElement, options) {
    var route = options.route,
        context = options.context;
    var localeData = context.localeData;

    var locale = route.data.locale;
    var store = void 0;
    if (options.preloadedState) {
      var preloadedState = options.preloadedState;

      var mergeState = Object.assign({}, options.initialState, preloadedState);
      store = (0, _redux.createStore)(reducer, mergeState);
    } else {
      store = (0, _redux.createStore)(reducer);
    }

    return _react2['default'].createElement(
      _reactIntl.IntlProvider,
      { locale: locale, messages: localeData[locale] },
      _react2['default'].createElement(
        _reactRedux.Provider,
        { store: store },
        _react2['default'].createElement(
          _reactRouterDom.StaticRouter,
          { location: route.path },
          appElement
        )
      )
    );
  };
  wrapSSR.displayName = 'wrapSSRCompoent';

  var cycle = {
    name: name,
    setOptions: setOptions,
    wrapSSR: wrapSSR
  };

  return (0, _ssrHelper.ssrDecorator)(cycle);
};

module.exports = exports['default'];