Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ssrHelper = require('../ssrHelper');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var pathToRegexp = require('path-to-regexp');

// create a match function
var createMatch = function createMatch(url) {
  return function (componentUrl) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    // exact default value is as same as react router default exact
    var exact = options.exact || false;
    var re = pathToRegexp(componentUrl, [], { end: exact });
    return re.exec(url);
  };
};

var route = function route(path, data) {
  return { path: path, data: data, match: createMatch(path) };
};

var RouterParamUrl = function () {
  function RouterParamUrl(_ref) {
    var url = _ref.url,
        _ref$dataProvider = _ref.dataProvider,
        dataProvider = _ref$dataProvider === undefined ? function () {
      return Promise.resolve([]);
    } : _ref$dataProvider;

    _classCallCheck(this, RouterParamUrl);

    this.url = url;
    this.toPath = pathToRegexp.compile(this.url);
    this.dataProvider = dataProvider;
  }

  _createClass(RouterParamUrl, [{
    key: 'getUrls',
    value: function () {
      var _ref2 = _asyncToGenerator(function* () {
        var _this = this;

        return this.dataProvider().then(function (data) {
          return data.map(function (row) {
            try {
              return route(_this.toPath(row), row);
            } catch (err) {
              // row not pass toPath, will throw TypeError
              // https://github.com/pillarjs/path-to-regexp#compile-reverse-path-to-regexp
              if (err instanceof TypeError) {
                return null;
              }

              // another error, throw
              throw err;
            }
          })
          // filter null
          .filter(function (row) {
            return row;
          });
        });
      });

      function getUrls() {
        return _ref2.apply(this, arguments);
      }

      return getUrls;
    }()
  }]);

  return RouterParamUrl;
}();

exports['default'] = function (routeParamsFn) {
  var name = 'routeParams';

  var cycle = {
    name: name,
    setRoute: function () {
      var _ref3 = _asyncToGenerator(function* (props, options) {
        var _routeParamsFn = routeParamsFn(props, options),
            url = _routeParamsFn.url,
            dataProvider = _routeParamsFn.dataProvider;

        return yield new RouterParamUrl({ url: url, dataProvider: dataProvider }).getUrls();
      });

      return function () {
        function setRoute(_x2, _x3) {
          return _ref3.apply(this, arguments);
        }

        return setRoute;
      }();
    }()
  };

  return (0, _ssrHelper.ssrDecorator)(cycle);
};

module.exports = exports['default'];