Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = findBabelConfig;

var _path = require('path');

var _buildConfigChain = require('babel-core/lib/transformation/file/options/build-config-chain');

var _buildConfigChain2 = _interopRequireDefault(_buildConfigChain);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

// ref: https://github.com/zeit/next.js/blob/v3-beta/server/build/babel/find-config.js
function findBabelConfig(dir) {
  dir = (0, _path.resolve)(dir);
  var filename = (0, _path.join)(dir, 'filename.js');
  var options = { babelrc: true, filename: filename };

  var configList = (0, _buildConfigChain2['default'])(options).filter(function (i) {
    return i.loc !== 'base';
  });

  // To prevent get the root babelrc config, only use the build folder's babelrc
  if (configList[0] && configList[0].dirname === dir) {
    return configList[0];
  }
  return false;
}
module.exports = exports['default'];