Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultConfig = undefined;
exports['default'] = loadCorenConfig;

var _path = require('path');

var _fs = require('fs');

var _noop = require('noop3');

var _noop2 = _interopRequireDefault(_noop);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var error = _utils.color.error;
var defaultConfig = exports.defaultConfig = {
  ssrWebpack: null,
  config: [],
  assetsHost: _noop2['default']
};

function loadCorenConfig(dir) {
  var path = (0, _path.resolve)(dir, 'coren.config.js');
  var config = defaultConfig;
  var hasConfig = (0, _fs.existsSync)(path);
  if (hasConfig) {
    var userConfig = require(path);
    if (!userConfig.entry) {
      throw new Error(error('Cannot find `entry` in coren.config.js'));
    }
    config = Object.assign({}, config, userConfig);
  } else {
    throw new Error(error('Please provide coren.config.js'));
  }
  // check assetsHost provide all enviroment case
  ['development', 'production'].forEach(function (env) {
    if (!config.assetsHost(env)) {
      throw new Error(error('Error: coren.config[assetsHost] doesn\'t provide \'' + String(env) + '\' environment return value '));
    }
  });
  return config;
}