var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _server = require('react-dom/server');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MultiRoutesRenderer = function () {
  function MultiRoutesRenderer(_ref) {
    var app = _ref.app,
        _ref$js = _ref.js,
        js = _ref$js === undefined ? [] : _ref$js,
        _ref$css = _ref.css,
        css = _ref$css === undefined ? [] : _ref$css,
        _ref$plugins = _ref.plugins,
        plugins = _ref$plugins === undefined ? [] : _ref$plugins,
        skipssr = _ref.skipssr,
        context = _ref.context;

    _classCallCheck(this, MultiRoutesRenderer);

    this.app = app;
    this.js = js;
    this.css = css;
    this.plugins = plugins;
    this.skipssr = skipssr;
    this.context = context;
  }

  _createClass(MultiRoutesRenderer, [{
    key: 'triggerPluginsLifecycle',
    value: function () {
      function triggerPluginsLifecycle(lifecycle, props) {
        this.plugins.forEach(function (plugin) {
          if (plugin[lifecycle]) {
            plugin[lifecycle](props);
          }
        });
      }

      return triggerPluginsLifecycle;
    }()
  }, {
    key: 'collectLifeCycleMethod',
    value: function () {
      function collectLifeCycleMethod(method) {
        var collected = {
          setOptions: [],
          appendToHead: [],
          appendToBody: [],
          wrapSSR: []
        };
        method.forEach(function (m) {
          for (var key in collected) {
            if (m[key]) {
              collected[key].push(m[key]);
            }
          }
        });
        return collected;
      }

      return collectLifeCycleMethod;
    }()
  }, {
    key: 'getRoutes',
    value: function () {
      var _ref2 = _asyncToGenerator(function* (componentMethod, props) {
        var routes = [];
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = componentMethod[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var method = _step.value;

            if (method.setRoute) {
              var methodRoute = yield method.setRoute(props, this.context);
              routes = [].concat(_toConsumableArray(routes), _toConsumableArray(methodRoute));
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator['return']) {
              _iterator['return']();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        return routes;
      });

      function getRoutes(_x, _x2) {
        return _ref2.apply(this, arguments);
      }

      return getRoutes;
    }()

    // import => prepare => construct => render => html

  }, {
    key: 'renderToString',
    value: function () {
      var _ref3 = _asyncToGenerator(function* () {
        var _this = this;

        // import
        var app = this.app['import']();
        var components = this.app.getComponents();
        var methods = this.app.getMethod();
        var componentProps = this.app.getProps();

        var results = [];
        for (var corenID in components) {
          console.log('Run corenID:', corenID);
          var props = componentProps[corenID];
          var collectedMethod = this.collectLifeCycleMethod(methods[corenID]);
          var routes = yield this.getRoutes(methods[corenID], props);
          // render each route's ssr page

          var _loop = function* _loop(i) {
            var route = routes[i];
            console.log('build route:', route.path);
            var template = createTemplate();
            var $ = _cheerio2['default'].load(template, { decodeEntities: false });
            var $head = $('head');
            var $body = $('body');
            var appElement = _react2['default'].createElement(app);
            var options = { route: route, context: _this.context };

            // Run lifecycle method
            // setOptions -> wrapSSR -> appendToHead -> appendToBody
            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
              for (var _iterator2 = collectedMethod.setOptions[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                var fn = _step2.value;

                options = Object.assign({}, options, (yield fn(props, options)));
              }
            } catch (err) {
              _didIteratorError2 = true;
              _iteratorError2 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion2 && _iterator2['return']) {
                  _iterator2['return']();
                }
              } finally {
                if (_didIteratorError2) {
                  throw _iteratorError2;
                }
              }
            }

            collectedMethod.wrapSSR.forEach(function (fn) {
              appElement = fn(appElement, options);
            });
            collectedMethod.appendToHead.forEach(function (fn) {
              return fn($head, options);
            });
            collectedMethod.appendToBody.forEach(function (fn) {
              return fn($body, options);
            });

            // Run plugin lifecycle: appDidRender -> jsDidAppend -> cssDidAppend
            // & Append js, css link
            _this.triggerPluginsLifecycle('appDidRender', { $head: $head, $body: $body });
            _this.js.forEach(function (bundle) {
              $('body').append('<script src="' + String(bundle) + '"></script>');
              _this.triggerPluginsLifecycle('jsDidAppend', { link: bundle, $head: $head, $body: $body });
            });
            _this.css.forEach(function (link) {
              $('head').append('<link rel="stylesheet" href="' + String(link) + '">');
              _this.triggerPluginsLifecycle('cssDidAppend', { link: link, $head: $head, $body: $body });
            });

            var markup = _this.skipssr ? '' : (0, _server.renderToString)(appElement);

            // insert rendered html
            $('#root').html(markup);
            results.push({ route: routes[i].path, html: $.html() });
          };

          for (var i = 0; i < routes.length; i++) {
            yield* _loop(i);
          }
        }

        return results;
      });

      function renderToString() {
        return _ref3.apply(this, arguments);
      }

      return renderToString;
    }()
  }]);

  return MultiRoutesRenderer;
}();

function createTemplate() {
  return '\n  <!doctype html>\n  <html>\n  <head>\n  <meta charset="utf-8">\n  <meta name="viewport" content="width=device-width, initial-scale=1">\n  </head>\n  <body><div id="root"></div></body>\n  </html>\n  ';
}

module.exports = MultiRoutesRenderer;