Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path = require('path');

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _app = require('./app');

var _app2 = _interopRequireDefault(_app);

var _multiRoutes = require('./ssr-renderers/multi-routes');

var _multiRoutes2 = _interopRequireDefault(_multiRoutes);

var _loadCorenConfig = require('./load-coren-config');

var _loadCorenConfig2 = _interopRequireDefault(_loadCorenConfig);

var _loadAssets = require('./load-assets');

var _loadAssets2 = _interopRequireDefault(_loadAssets);

var _corenWorkingSpace = require('./coren-working-space');

var _config = require('./config');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var fs = _bluebird2['default'].promisifyAll(require("fs"));

var Entry = function () {
  function Entry(_ref) {
    var assets = _ref.assets,
        dir = _ref.dir,
        path = _ref.path,
        config = _ref.config,
        _ref$skipssr = _ref.skipssr,
        skipssr = _ref$skipssr === undefined ? false : _ref$skipssr,
        env = _ref.env;

    _classCallCheck(this, Entry);

    this.assets = assets;
    this.dir = dir;
    this.skipssr = skipssr;
    this.config = config;
    this.env = env;
    this.ssrDir = (0, _corenWorkingSpace.getSsrDir)(dir);
    this.app = new _app2['default']({ path: path });
  }

  _createClass(Entry, [{
    key: 'genAssets',
    value: function () {
      function genAssets() {
        var _this = this;

        var assets = { js: [], css: [] };
        if (this.assets['.js']) {
          this.assets['.js'].forEach(function (js) {
            assets.js.push(_this.assetRelative(js));
          });
        }
        if (this.assets['.css']) {
          this.assets['.css'].forEach(function (css) {
            assets.css.push(_this.assetRelative(css));
          });
        }
        return assets;
      }

      return genAssets;
    }()
  }, {
    key: 'assetRelative',
    value: function () {
      function assetRelative(absolutePath) {
        return this.config.assetsHost(this.env, absolutePath);
      }

      return assetRelative;
    }()
  }, {
    key: 'genOutputPath',
    value: function () {
      function genOutputPath(route) {
        var outputPath = String(route) + '/index.html';
        if (route === '/') {
          outputPath = 'index.html';
        }
        return (0, _path.join)(this.ssrDir, outputPath);
      }

      return genOutputPath;
    }()
  }, {
    key: 'render',
    value: function () {
      function render(context) {
        var _this2 = this;

        var _genAssets = this.genAssets(),
            js = _genAssets.js,
            css = _genAssets.css;

        var options = {
          app: this.app,
          plugins: this.config.plugins,
          skipssr: this.skipssr,
          context: context,
          js: js,
          css: css
        };

        var ssr = new _multiRoutes2['default'](options);

        // get the array of html result
        return ssr.renderToString().then(function (results) {
          // output file
          return _bluebird2['default'].all(results.map(function (result) {
            var filepath = _this2.genOutputPath(result.route);
            _mkdirp2['default'].sync((0, _path.resolve)(filepath, "../"));
            // write to filesystem
            return fs.writeFileAsync(filepath, result.html);
          }));
        })['catch'](function (err) {
          return console.log(err);
        });
      }

      return render;
    }()
  }]);

  return Entry;
}();

var ssr = function () {
  function ssr(_ref2) {
    var dir = _ref2.dir,
        skipssr = _ref2.skipssr,
        env = _ref2.env;

    _classCallCheck(this, ssr);

    this.dir = dir;
    this.config = (0, _loadCorenConfig2['default'])(dir);
    var entry = this.config.entry;

    this.entries = [];
    var assets = (0, _loadAssets2['default'])(dir);
    for (var key in entry) {
      if (!_config.preserveEntry.includes(key)) {
        this.entries.push(new Entry({
          assets: this.generateEntryAssets(assets, key),
          path: (0, _path.resolve)((0, _corenWorkingSpace.getCommonJSDir)(dir), key + '.commonjs2.js'),
          config: this.config,
          dir: dir,
          skipssr: skipssr,
          env: env
        }));
      }
    }
  }

  // merge the preserve assets key with app's assets


  _createClass(ssr, [{
    key: 'generateEntryAssets',
    value: function () {
      function generateEntryAssets(assets, entry) {
        var entryAsset = assets[entry];
        // vendor file need to put before other assets.
        if (assets.$vendor) {
          ['.js', '.css'].forEach(function (ext) {
            if (assets.$vendor[ext]) {
              if (!entryAsset[ext]) {
                entryAsset[ext] = [];
              }
              entryAsset[ext] = [].concat(_toConsumableArray(assets.$vendor[ext]), _toConsumableArray(entryAsset[ext]));
            }
          });
        }
        return entryAsset;
      }

      return generateEntryAssets;
    }()
  }, {
    key: 'prepareContext',
    value: function () {
      function prepareContext() {
        var _this3 = this;

        var prepareContext = this.config.prepareContext;

        if (prepareContext) {
          return prepareContext().then(function (context) {
            _this3.context = context;
          });
        }
        return _bluebird2['default'].resolve();
      }

      return prepareContext;
    }()
  }, {
    key: 'render',
    value: function () {
      function render() {
        var _this4 = this;

        return this.prepareContext().then(function () {
          return _bluebird2['default'].all(_this4.entries.map(function (entry) {
            return entry.render(_this4.context);
          }));
        });
      }

      return render;
    }()
  }]);

  return ssr;
}();

exports['default'] = ssr;
module.exports = exports['default'];