Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = createWebpackConfig;

var _clientConfig = require('./client-config');

var _clientConfig2 = _interopRequireDefault(_clientConfig);

var _serverConfig = require('./server-config');

var _serverConfig2 = _interopRequireDefault(_serverConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function createWebpackConfig() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      dir = _ref.dir,
      _ref$dev = _ref.dev,
      dev = _ref$dev === undefined ? false : _ref$dev,
      corenConfig = _ref.corenConfig,
      clientWebpackPath = _ref.clientWebpackPath;

  var clientCompiler = void 0;
  if (clientWebpackPath) {
    clientCompiler = (0, _clientConfig2['default'])({ config: require(clientWebpackPath) });
  }
  var serverCompiler = (0, _serverConfig2['default'])({ dir: dir, dev: dev, corenConfig: corenConfig });
  return {
    clientCompiler: clientCompiler, serverCompiler: serverCompiler
  };
}
module.exports = exports['default'];