Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _corenWorkingSpace = require('../../coren-working-space');

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var emited = false;

var AssetsPath = function () {
  function AssetsPath(_ref) {
    var rootDir = _ref.rootDir;

    _classCallCheck(this, AssetsPath);

    this.rootDir = rootDir;
  }

  _createClass(AssetsPath, [{
    key: 'apply',
    value: function () {
      function apply(compiler) {
        var _this = this;

        var assetsPath = {};
        compiler.plugin('after-emit', function (compilation, cb) {
          if (emited) {
            cb();
          } else {
            (function () {
              var assets = compilation.assets;
              var stats = compilation.getStats().toJson({
                hash: true,
                publicPath: true,
                assets: true,
                chunks: false,
                modules: false,
                source: false,
                errorDetails: false,
                timings: false
              });
              var assetsByChunkName = stats.assetsByChunkName;

              var _loop = function () {
                function _loop(entry) {
                  var chunks = assetsByChunkName[entry];
                  chunks = (0, _lodash.isString)(chunks) ? [chunks] : chunks;
                  chunks.forEach(function (chunk) {
                    var ext = _path2['default'].extname(chunk);
                    if (!assetsPath[entry]) {
                      assetsPath[entry] = {};
                    }
                    assetsPath[entry][ext] = [assets[chunk].existsAt];
                  });
                }

                return _loop;
              }();

              for (var entry in assetsByChunkName) {
                _loop(entry);
              }
              _mkdirp2['default'].sync((0, _corenWorkingSpace.getRootPath)(_this.rootDir)); // because plugin would be used by client webpack, need to create dir
              emited = true;
              _fs2['default'].writeFile((0, _corenWorkingSpace.getAssetsJsonPath)(_this.rootDir), JSON.stringify(assetsPath), function (err) {
                if (err) {
                  throw new Error(err);
                }
                cb();
              });
            })();
          }
        });
      }

      return apply;
    }()
  }]);

  return AssetsPath;
}();

exports['default'] = AssetsPath;
module.exports = exports['default'];