Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = serverWebpackConfig;

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _path = require('path');

var _webpackNodeExternals = require('webpack-node-externals');

var _webpackNodeExternals2 = _interopRequireDefault(_webpackNodeExternals);

var _getBabelConfig = require('../babel/get-babel-config');

var _getBabelConfig2 = _interopRequireDefault(_getBabelConfig);

var _corenWorkingSpace = require('../coren-working-space');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function serverWebpackConfig(_ref) {
  var _ref$dev = _ref.dev,
      dev = _ref$dev === undefined ? false : _ref$dev,
      dir = _ref.dir,
      corenConfig = _ref.corenConfig;

  var env = dev ? 'development' : 'production';
  var config = {
    entry: corenConfig.entry,
    target: 'node',
    output: {
      path: (0, _corenWorkingSpace.getCommonJSDir)(dir),
      filename: '[name].commonjs2.js',
      libraryTarget: 'commonjs2'
    },
    resolve: {
      extensions: ['.js']
    },
    externals: [(0, _webpackNodeExternals2['default'])(), /^(coren|\$)$/i],
    plugins: [new _webpack2['default'].DefinePlugin({
      "process.env": {
        NODE_ENV: JSON.stringify(env),
        isBrowser: false
      }
    })],
    module: {
      rules: [{
        test: /\.js$/,
        use: {
          loader: 'babel-loader',
          options: (0, _getBabelConfig2['default'])(dir)
        },
        exclude: (0, _path.resolve)(dir, "node_modules")
      }]
    }
  };
  if (corenConfig.ssrWebpack) {
    if (corenConfig.ssrWebpack.plugins) {
      config = Object.assign({}, config, {
        plugins: [].concat(_toConsumableArray(config.plugins), _toConsumableArray(corenConfig.ssrWebpack.plugins))
      });
    }

    if (corenConfig.ssrWebpack.module && corenConfig.ssrWebpack.module.rules) {
      config = Object.assign({}, config, {
        module: {
          rules: [].concat(_toConsumableArray(config.module.rules), _toConsumableArray(corenConfig.ssrWebpack.module.rules))
        }
      });
    }
    if (corenConfig.ssrWebpack.externals) {
      config = Object.assign({}, config, {
        externals: [].concat(_toConsumableArray(config.externals), _toConsumableArray(corenConfig.ssrWebpack.externals))
      });
    }
  }
  return (0, _webpack2['default'])(config);
}
module.exports = exports['default'];